
PLineHL CreateColors(int lnum,int fst)
{
PLineHL lines = new SLineHL[lnum+1];
  memset(lines, 0, sizeof(SLineHL)*(lnum+1));
  lines[0].start = fst;
  lines[0].end = lnum;
  return lines;
};

bool DestroyColors(PLineHL line)
{
  for(int i=1;i<line[0].end+1;i++)
    ClearLine(line,i);
  delete[] line;
  return true;
};

bool AddColor(PLineHL line, int lno, int s, int e, int col)
{
PLineHL ln,ln1;
  if (line[0].start+line[0].end <= lno || lno < line[0].start) return false;
  ln = &line[1+lno-line[0].start];

  ln1 = new SLineHL;
  ln1->start = s;
  ln1->end = e;
  ln1->color = col;
  ln1->next = NULL;
  if (!ln->last)
    ln->next = ln->last = ln1;
  else{
    ln->last->next = ln1;
    ln->last = ln1;
  };
  return true;
};

bool ClearLine(PLineHL line, int lno)
{
PLineHL ln,ln1;
  if (line[0].start+line[0].end <= lno || lno < line[0].start) return false;
  ln = &line[1+lno-line[0].start];
  ln1 = ln->next;
  ln->next = NULL;
  ln->last = NULL;
  while(ln1){
    ln = ln1;
    ln1=ln1->next;
    delete ln;
  };
  return true;
};

PLineHL AddRegion(PLineHL nb, PLineHL line)
{
PLineHL ln, ln1, lnprev, lnprev2 = NULL, newl;
  if (line->start == line->end) return nb;
  newl = new SLineHL;
  *newl = *line;
  newl->next = NULL;
  if (!nb)
    return newl;
  for(ln = nb; ln; lnprev2 = ln, ln = ln->next){
    if (nb->start >= newl->start){
      newl->next = nb;
      nb = newl;
      lnprev = NULL;
      break;
    };
    if (ln->start == newl->start){
      lnprev2->next = newl;
      newl->next = ln;
      lnprev = lnprev2;
      lnprev2 = NULL;
      break;
    };
    if (ln->start < newl->start && !ln->next){
      ln->next = newl;
      newl->next = NULL;
      lnprev = ln;
      break;
    };
    if (ln->start < newl->start && ln->next->start > newl->start){
      newl->next = ln->next;
      ln->next = newl;
      lnprev = ln;
      break;
    };
  };
  if (lnprev && lnprev->end > newl->start){
    if (lnprev->end > newl->end){
      ln1 = new SLineHL;
      *ln1 = *lnprev;
      ln1->next = newl->next;
      newl->next = ln1;
      ln1->start=newl->end;
    };
    lnprev->end = newl->start;
    if (lnprev2 && lnprev->end == lnprev->start){
      lnprev2->next = newl;
      delete lnprev;
    };
    if (!lnprev2 && lnprev->end == lnprev->start){
      delete lnprev;
      nb = newl;
    };
  };
  ln = newl->next;
  while(ln){
    if (ln->end > newl->end && ln->start < newl->end)
      ln->start = newl->end;
    if (ln->end <= newl->end){
      newl->next = ln->next;
      ln1 = ln->next;
      delete ln;
      ln = ln1;
      continue;
    };
    ln = ln->next;
  };
  return nb;
};

bool CompactLines(PLineHL Lines)
{
PLineHL ln, newlbase;
  if (!Lines) return false;
  for(int i = 1; i <= Lines[0].end; i++){
    ln = Lines[i].next;
    newlbase = NULL;
    while(ln){
      newlbase = AddRegion(newlbase, ln);
      ln = ln->next;
    };
    ClearLine(Lines,Lines[0].start+i-1);
    Lines[i].next = newlbase;
  };
  return true;
};
