//
//  Copyright (c) Cail Lomecb (Igor Ruskih) 1999-2000 <ruiv@uic.nnov.ru>
//  You can use, modify, distribute this code or any other part
//  of this program in sources or in binaries only according
//  to License (see /doc/(rus/)?license.txt for more information).
//
#include<string.h>
#include<math.h>
#include<float.h>

#include<defs.h>

bool GetNumber(char *Str, double *Res)
{
double Numr, r, flt;
int    pos, Type, Num;
int    s, e, i, j, pt, k, ExpS, ExpE;
bool   Exp = false, ExpSign = true;

pos = strlen(Str);

s = 0;
e = pos;
Type = 3;
do{
  if(Str[0] == '0' && (Str[1] == 'x' || Str[1] == 'X')){
    s = 2;
    Type = 0;
    break;
  };
  if (Str[e-1] == 'h' || Str[e-1] == 'H'){
    e--;
    Type = 0;
    break;
  };
  if (Str[0] == '$' || Str[0] == '#'){
    s = 1;
    Type = 0;
    break;
  };
  if (Str[e-1] == 'o' || Str[e-1] == 'O'){
    e--;
    Type = 1; // Oct
    break;
  };
  if (Str[0] == '0'){
    Type = 1;
    for(i = s;i < e;i++){
      if (Str[i] == '.') Type = 3;
      if (Str[i] == 'e' || Str[i] =='E') Type = 3;
    };
  };
  if (Str[e-1] == 'b' || Str[e-1] == 'B'){
    e--;
    Type = 2;
    break;
  };
  if (Str[e-1] == 'd' || Str[e-1] == 'D'){
    e--;
    Type = 3;
    break;
  };
  break;
}while(1);

switch(Type){
  case 0:
    Num = 0;
    i = e-1;
    while(i >= s){
      j = Str[i];
      if(((j < 0x30) || (j > 0x39)) &&
        (((j | 0x20) < 'a') || ((j | 0x20) > 'f')))
          return false;
      if(j > 0x40) j -=7;
      j &=15;
      if(i > e-9) Num |= (j << ((e-i-1)*4) );
      i--;
    };
    *Res = (int)Num;
    break;
  case 1:
    Num = 0;
    i = e-1;
    while(i >= s){
      j = Str[i];
      if((j < 0x30) || (j > 0x37))
        return false;
      if(j > 0x40) j -=7;
        j &=15;
      if(i > e-12) Num |= (j << ((e-i-1)*3) );
        i--;
    };
    *Res = (int)Num;
    break;
  case 2:
    Num = 0;
    i = e-1;
    while(i >= s){
      j = Str[i];
      if((j < 0x30) || (j > 0x31))
        return false;
      j &= 1;
      if (i > e-33) Num |= (j << (e-i-1));
        i--;
    };
    *Res = (int)Num;
    break;
  case 3:
    for(i = s;i < e;i++)
    if (Str[i] == 'e' || Str[i] =='E'){
      Exp = true;
      ExpS = i+1;
      if (Str[i+1] == '+' || Str[i+1] == '-'){
        ExpS++;
        if (Str[i+1] == '-') ExpSign = false;
      };
      ExpE = e;
      e = i;
    };
    pt = e;
    for(i = s;i < e;i++)
      if (Str[i] == '.'){
        pt = i;
        break;
      };
    Numr = 0;
    i = pt-1;
    while(i >= s){
      j = Str[i];
      if((j < 0x30)||(j > 0x39))
        return false;
      j &=15;
      k = pt-i-1;
      r = (long double)j;
      while(k){
        k--;
        r *=10;
      };
      Numr += r;
      i--;
    };
    i = e-1;
    while(i > pt){
      j = Str[i];
      if((j < 0x30)||(j > 0x39))
        return false;
      j &=15;
      k = i-pt;
      r = 0;
      r = j;
      while(k){
        k--;
        r /=10;
      };
      Numr += r;
      i--;
    };
    if (Exp){
      flt = 0;
      i = ExpE-1;
      while(i >= ExpS){
        j = Str[i];
        if((j < 0x30)||(j > 0x39))
          return false;
        j &=15;
        k = ExpE-i-1;
        r = (long double)j;
        while(k){
          k--;
          r *=10;
        };
        flt += r;
        i--;
      };
      if (ExpSign)  Numr = Numr*pow(10,flt);
      if (!ExpSign) Numr = Numr/pow(10,flt);
    };
    *Res = Numr;
    break;
};
return true;
};
